package splash_screen_on_boot.java;

import javafx.concurrent.Task;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import uploading_to_bulletin_board.java.UploadingToBulletinBoardLoader;

import java.io.IOException;

/**
 * Created by Vladimir Eliezer Tokarev on 28/05/2016.
 * SplashScreenOnBootLoader starts the entry point into meerkat it displays the loading
 */
public class SplashScreenOnBootLoader {

    private static final String SPALSH_SCREEN_ON_BOOT_FXML_PATH = "../fxml/spalsh_screen_on_boot.fxml";
    private static final int TWO_SECONDS_TIMEOUT_IN_MILLISECONDS = 1000;

    private Stage currentStage;

    public SplashScreenOnBootLoader(Stage primaryStage) throws IOException
    {
        Parent splashScreenOnBootRoot = FXMLLoader.load(getClass().getResource(SPALSH_SCREEN_ON_BOOT_FXML_PATH));
        currentStage = primaryStage;
        currentStage.setScene(new Scene(splashScreenOnBootRoot, 565, 365));
        IntroSleep();
    }

    /**
     * After the splash screen displayed wait -
     * two seconds and than continue to StartUploadingToBulletinBoard
     */
    private void IntroSleep()
    {
        Task<Void> sleeper = new Task<Void>() {
            @Override
            protected Void call() throws Exception {
                Thread.sleep(TWO_SECONDS_TIMEOUT_IN_MILLISECONDS);
                return null;
            }
        };
        sleeper.setOnSucceeded(event -> {
            try {
                StartUploadingToBulletinBoard();
            } catch (IOException e) {
                e.printStackTrace();
            }
        });
        new Thread(sleeper).start();
    }

    /**
     * Creates instance of uploading to bulletin board and set it as the scene
     */
    private void StartUploadingToBulletinBoard() throws IOException
    {
        new UploadingToBulletinBoardLoader(currentStage);
    }


}
